"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.test = exports.serialize = exports.default = void 0;

var _ansiRegex = _interopRequireDefault(require("ansi-regex"));

var _ansiStyles = _interopRequireDefault(require("ansi-styles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright (c) Facebook, Inc. and its affiliates. All Rights Reserved.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
const toHumanReadableAnsi = text => text.replace((0, _ansiRegex.default)(), match => {
  switch (match) {
    // @ts-ignore
    case _ansiStyles.default.red.close: // @ts-ignore

    case _ansiStyles.default.green.close: // @ts-ignore

    case _ansiStyles.default.cyan.close: // @ts-ignore

    case _ansiStyles.default.gray.close: // @ts-ignore

    case _ansiStyles.default.white.close: // @ts-ignore

    case _ansiStyles.default.yellow.close: // @ts-ignore

    case _ansiStyles.default.bgRed.close: // @ts-ignore

    case _ansiStyles.default.bgGreen.close: // @ts-ignore

    case _ansiStyles.default.bgYellow.close: // @ts-ignore

    case _ansiStyles.default.inverse.close: // @ts-ignore

    case _ansiStyles.default.dim.close: // @ts-ignore

    case _ansiStyles.default.bold.close: // @ts-ignore

    case _ansiStyles.default.reset.open: // @ts-ignore

    case _ansiStyles.default.reset.close:
      return '</>';
    // @ts-ignore

    case _ansiStyles.default.red.open:
      return '<red>';
    // @ts-ignore

    case _ansiStyles.default.green.open:
      return '<green>';
    // @ts-ignore

    case _ansiStyles.default.cyan.open:
      return '<cyan>';
    // @ts-ignore

    case _ansiStyles.default.gray.open:
      return '<gray>';
    // @ts-ignore

    case _ansiStyles.default.white.open:
      return '<white>';
    // @ts-ignore

    case _ansiStyles.default.yellow.open:
      return '<yellow>';
    // @ts-ignore

    case _ansiStyles.default.bgRed.open:
      return '<bgRed>';
    // @ts-ignore

    case _ansiStyles.default.bgGreen.open:
      return '<bgGreen>';
    // @ts-ignore

    case _ansiStyles.default.bgYellow.open:
      return '<bgYellow>';
    // @ts-ignore

    case _ansiStyles.default.inverse.open:
      return '<inverse>';
    // @ts-ignore

    case _ansiStyles.default.dim.open:
      return '<dim>';
    // @ts-ignore

    case _ansiStyles.default.bold.open:
      return '<bold>';

    default:
      return '';
  }
});

const test = val => typeof val === 'string' && !!val.match((0, _ansiRegex.default)());

exports.test = test;

const serialize = (val, config, indentation, depth, refs, printer) => printer(toHumanReadableAnsi(val), config, indentation, depth, refs);

exports.serialize = serialize;
const plugin = {
  serialize,
  test
};
var _default = plugin;
exports.default = _default;